%define oldversion 20.7
%define shortname emacs
Name: emacs21
Version: 21.3
Release: alt11.M24.vla2

Packager: Ivan Zakharyaschev <imz@altlinux.ru>

Group: Editors
Summary: GNU Emacs text editor
License: GPL

URL: http://www.gnu.org/software/emacs/

%if "%imz__light_sources" == "1"
# "Light" versions (uncompressed for faster %prep)
Source0: rsync://ftp.gnu.org/gnu/%shortname/%shortname-%version.tar
Source1: rsync://ftp.gnu.org/gnu/%shortname/leim-%version.tar
%else
Source0: rsync://ftp.gnu.org/gnu/%shortname/%shortname-%version.tar.bz2
Source1: rsync://ftp.gnu.org/gnu/%shortname/leim-%version.tar.bz2
%endif
Source2: TUTORIAL.ru
Source3: smtpmail.el

Source7: README.KOI8-U

#Source110: http://prdownloads.sourceforge.net/php-mode/php-mode.el
#Source111: emacs-mode-php.site-start.el

Source12: gnu-mini.xpm
Source13: gnu-normal.xpm
Source14: gnu-large.xpm

# from Serhij Hlodin
Source16: CHANGES.ukr
Source17: INSTALL.ukr
Source18: README.UK

Source22: %name.menu
Source24: %name.alternatives

# Mdk's and ALT's global configs merged: the X resources
Source31: %shortname-21.2-alt14-xresources-ALT

# List of some large .elc files to be compressed:
#Source40: %shortname-21.2-el-to-compress.ls

Source41: emacs21-rus-win-keyboard-alt2.el

################### Patches  ##########################
# ALT's libtinfo; POSIX locks via fcntl convention:
Patch0: %shortname-21.2-alt-system.patch

# Try to load also bzipped2 .el/.elc files 
# as well as with gzipped and uncompressed variants (supported before)
Patch1: %shortname-21.2-alt14-load-el_bz2.patch
# isn't applied (21.2-alt1): indicator is already disabled in the GNU release:
Patch2: %shortname-21.1-enc-kb-short-indicator.patch
Patch3: %shortname-21.3-alt3-clipboard.patch

# We don't want the whole pkg depend on rcs 
# just because someone may want to use it:
Patch4: %shortname-21.2-hide-rcs-deps.patch
Patch5: %shortname-21.2-Meta-Alt-Ctrl-Hyper-super-discard-state.patch
# the freshest pc-select.el (from the HEAD of CVS)
Patch6: %shortname-21.2-HEAD-pc-select.diff
Patch7: %shortname-21.2-pc-select-private-mark.patch
Patch8: %shortname-21.2-ediff-diff-options-check-c.patch
Patch10: %shortname-21.2-face-font-selection-slant-important.patch
Patch11: %shortname-21.3-use-handler-for-load-of-absolute.patch
Patch12: %shortname-21.3-use-handler-for-load-of-suffixed.patch
Patch13: %shortname-21.3-vc-cvs-registered-autoload-parts.patch
Patch14: %shortname-21.3-rh-no_rpath.patch
Patch15: %shortname-21.2-x86_64.patch

# These two patches make the real work for ukrainisation:
Patch20: %shortname-21.3-alt4-uk.patch
Patch21: leim-21.1-uk.patch
Patch22: leim-20.6-belarusian.patch
# added belarussian and proprer russianw dictionary support
Patch23: %shortname-21.3-ispell-belarusian.patch
Patch24: %shortname-21.3-ispell-russianw.patch



Patch33: %shortname-21.3-alt1-more-cyrillic-support.patch
#Patch33: %shortname-21.2-alt10-cyrillic-cp-lang-envs.patch
Patch34: %shortname-21.1-lang-env-prereqs.patch

Patch35: %shortname-21.2-alt12-tutorial-ru.patch

# End of Patches #
##################

# We use awk for output parsing and error-msg detection:
BuildRequires(build): awk
# We use zme:
BuildRequires(install): bzip2-utils
# <term.h> is there since then:
BuildRequires(build): libtinfo >= 5.2.20020622-alt2

BuildRequires(build): autoconf_2.13
%set_autoconf_version 2.13

# %_configure_target must set --host= for a correct emacs build;
# added since then:
BuildRequires(build): rpm >= 4.0.4-alt12

# We need sendmail to properly dump emacs during bootstrap
BuildRequires(build): sendmail-common

# We need emacs-base
BuildPreReq: %shortname-base >= 0.0.4-alt1
BuildRequires(build): %shortname-base >= 0.0.4-alt1

# The %_altdir macro is there AFAIU.
BuildRequires(install): libalternatives-devel

# All emacs pkgs should be removed from the list.
# XFree86-devel or XFree86-devel-static?

# Strange build deps:
#BuildRequires: inews  postfix

# Automatically added by buildreq on Wed Mar 12 2003
BuildRequires: XFree86-devel XFree86-libs XFree86-locales libXaw3d-devel libalternatives-devel libjpeg-devel libncurses-devel libpng-devel libtiff-devel libtinfo-devel libungif-devel xpm-devel zlib-devel emacs-base

%description
Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

%package common
Summary: Things needed to run the GNU Emacs text editor
Group: Editors
Obsoletes: %name
Obsoletes: %shortname-common
Provides: %shortname-common = %version-%release
# Common is useless without an Emacs binary:
Requires: %name = %version-%release
# We do not include speedbar from GNU's distro;
# so we require th external one.
# !!!     
#Requires: %shortname-speedbar
#alternatives must be installed before this package
PreReq: alternatives >= 0.0.6

Requires: emacs-base >= 0.0.4-alt1

Conflicts: etcskel < 2.0.2-alt1
Conflicts: emacs-prog-modes < 0.1-alt7
# ispell-uk 0.5 is broken, and can cause hang in flyspell mode
Conflicts: ispell-uk < 0.6-alt1

%description common
GNU Emacs is an extensible, customizable, self-documenting real-time
display editor.  Emacs contains special code editing features, an
extension language (Emacs Lisp), and the capability to read mail, news
and more without leaving the editor.

This package includes things you need to run the Emacs editor, so you
need to install this package if you intend to use Emacs.  You also
need to install the actual Emacs program package (%name-nox or
%name-X11).  Install %name-nox if you are not going to use the X
Window System; install %name-X11 if you will be using X.

%package el
Summary: The sources for Lisp programs included with GNU Emacs
Group: Development/Other
Requires: %name-common = %version-%release
Obsoletes: %shortname-el
Provides: %shortname-el = %version-%release

%description el
Emacs-el contains the Emacs Lisp sources for many of the programs
included with the main GNU Emacs text editor package.

You need to install %name-el only if you intend to modify any of the
Emacs packages or see some Lisp examples.

If you need the sources for %name-leim, install %name-leim-el.

%package leim
Summary: GNU Emacs Lisp code for input methods for internationalization
Group: Editors
Requires: %name-common = %version-%release
Obsoletes: %shortname-leim
Provides: %shortname-leim = %version-%release

%description leim
The Lisp code for input methods for various international scripts for GNU Emacs.

%package leim-el
Summary: The Emacs Lisp source code for input methods included in %name-leim
Group: Development/Other
Requires: %name-leim = %version-%release
Obsoletes: %shortname-leim-el
Provides: %shortname-leim-el = %version-%release

%description leim-el
Emacs-leim-el contains the Emacs Lisp sources for the Emacs Lisp code
for input methods for various international scripts of GNU Emacs.

You need to install %name-leim-el only if you intend to modify any of theses
GNU Emacs packages, see some Lisp examples or for reference for configuring your
localized input methods.

#
%package nox
Summary: The GNU Emacs text editor without support for the X Window System
Group: Editors
PreReq: %name-common = %version-%release
Provides: %name = %version-%release
Requires: emacs-base
Provides: emacsen
Provides: %shortname = %version-%release
Obsoletes: %shortname-nox
Provides: %shortname-nox = %version-%release

%description nox
Emacs-nox is the GNU Emacs text editor program without support for
the X Window System.

You need to install this package only if you plan on exclusively using
GNU Emacs without the X Window System (%name-X11 will work both in X and out
of X, but %name-nox will only work outside of X).  You will also need to
install the %name-common package in order to run GNU Emacs.

#
%package X11
Summary: The GNU Emacs text editor for the X Window System
Group: Editors
PreReq: %name-common = %version-%release
Provides: %name = %version-%release
Requires: emacs-base
Provides: emacsen
Provides: %shortname = %version-%release
Conflicts: app-defaults < 0.2.1-alt1
Obsoletes: %shortname-X11
Provides: %shortname-X11 = %version-%release

%description X11
Emacs-X11 includes the GNU Emacs text editor program for use with the X
Window System (it provides support for the mouse and other GUI
elements).  Emacs-X11 will also run GNU Emacs outside of X, but it has a
larger memory footprint than the 'non-X' GNU Emacs package (%name-nox).

Install %name-X11 if you are going to use Emacs with the X Window
System.  You should also install %name-X11 if you are going to run
GNU Emacs both with and without X (it will work fine both ways).  You will
also need to install the %name-common package in order to run Emacs.

%prep
%setup -q -b1 -n %shortname-%version

%patch0 -p1
%patch1 -p1
# The indicator turned off in GNU's 21.2 release, the patch no needed so far. 
#%patch2 -p1
%patch3 -p1

%patch4 -p1
%patch5 -p1 -b .ctrl
%patch6 -p2
%patch7 -p1
%patch8 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1

# tutorial in Russian:
cp %SOURCE2 etc

cp %SOURCE3 lisp/mail/smtpmail.el

# Ukrainian docs:
cp %SOURCE16 .
cp %SOURCE17 .
cp %SOURCE18 .
cp %SOURCE7 .

%patch20 -p1
%patch21 -p1
%patch22 -p0
%patch23 -p1
%patch24 -p1

# add support for prereq-features of language-environment-info
%patch34 -p1
# add CP*-based lang-envs and font support:
%patch33 -p1

%patch35 -p1

# support for russianw ispell dictionary is moved to Patch24

perl -pi -e 's|(\.\./info/[[:alpha:]-]+)|$1.info|g' man/*
rm -f info/*

%define Substage printf 'Substage #%s. %s:\\n'

# We build two binaries (with X and without X support) 
# in several symmetric substages.

%Substage 0 "Clear and create the both build directories"
[ -d build-nox ] && %__rm -rf build-nox; %__mkdir_p build-nox
[ -d build-withx ] && %__rm -rf build-withx; %__mkdir_p build-withx

%build
%__autoconf
# Try to detect errors and break on errors:
%define detect_elisp_errs 2>&1 | awk '/!! /{ r++; } END{ if (r) printf "There were %%d errors while recompiling Emacs Lisp modules.\\n", r; exit r; } /.*/'

# We do not want to use anything from an existing Emacs installation:
export EMACSLOADPATH="$(pwd)"/lisp

%Substage 1 "Configure"
%define _configure_script ../configure
pushd build-nox
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x=no
popd
pushd build-withx
%configure --sharedstatedir=/var --with-gcc --with-pop --with-x-toolkit --with-png --with-jpeg --with-xpm --with-gif --with-tiff
popd

%Substage 2 "Initial make all" 
#no SMP
pushd build-nox; make; popd
pushd build-withx; make; popd

%Substage 3 "Make supplementary (and important) things only once (asymmetricly) 
 (for possibly more capabilities -- in the X build)"
pushd build-withx
make -C man
{
    # Recompile so that the patches we have applied are effective:
    # The goal `updates' should update all the generated code
    # (autoloads, custom-deps etc.). 
    # Also compile php-mode and the small new file for Cyrillic support.
    make -C lisp \
	updates \
	international/cyrillic-codepages-setup.elc \
	recompile
#	progmodes/php-mode.elc \
} %detect_elisp_errs
popd # build-withx

%Substage 4 "Final make all (now that we have all patched Lisp code compiled, 
 also a bit asymmetric), clean previous binaries"
#no SMP
pushd build-withx
  %__rm -f src/emacs src/emacs-*
  make
popd
pushd build-nox
  # Override some data with more complete from the X build
  # (exactly the X variant of the data will be included in the package,
  # so emacs-nox has to work correctly in this environment):
  %__rm -rf etc leim; %__ln_s -f ../build-withx/{etc,leim} .
  %__rm -f src/emacs src/emacs-*
  make
popd


%install
mkdir -p "$RPM_BUILD_ROOT"%prefix
%makeinstall -C build-withx INSTALL_INFO=%__install_info
install -p -m755 build-nox/src/%shortname "$RPM_BUILD_ROOT"%_bindir/%name-nox
mv $RPM_BUILD_ROOT%_bindir/%shortname-%version $RPM_BUILD_ROOT%_bindir/%name-X11
# remove the installed duplicate emacs binary
# -- it'll be a link managed by `alternatives':
%__rm -f "$RPM_BUILD_ROOT"%_bindir/%shortname


# All the install's below have nothing to do with the Source directory
# So we want to make the command arguments shorter 
# by replacing "$RPM_BUILD_ROOT" with "."
pushd "$RPM_BUILD_ROOT" # there will be a popd below

# leim's Makefile doesn't ignore .orig; remnove them:
find .%_datadir/%shortname/%version/leim -type f -name '*.orig' -print0 \
	| xargs -0 rm -f

# Compress some files: 
#{ 
#    cat %SOURCE40 | sed -e 's:^:.%_datadir/%shortname/%version/:'
#    for o in .%_datadir/%shortname/%version/lisp/obsolete/*.elc; do echo "$o"; done  
#} | xargs gzip -9 -v 2>&1 | sed -e 's@:.*$@.gz@' | xargs zme

# Site start configuration:
# Link to a file provided by emacsen-startscripts pkg:
(cd .%_datadir/emacs/%version/lisp; ln -s ../../../../..%_sysconfdir/emacs/site-start.el)
# making start scripts
%__mkdir -p %buildroot%_sysconfdir/emacs/site-start.d/
%__install -p -m0644 %SOURCE41 %buildroot%_sysconfdir/emacs/site-start.d


#######################
# Various other stuff #
#######################

%__mkdir -p .%_libdir/%shortname/site-lisp

%__mv .%_mandir/man1/{,g}ctags.1
%__mv .%_bindir/{,g}ctags

# Exclude speedbar:
%__rm -f .{%_datadir/%shortname/%version/lisp,%_infodir}/speedbar*

# Exclude antlr-mode:
%__rm -f .%_datadir/%shortname/%version/lisp/progmodes/antlr-mode.el*

# Remove Gnus:
%__rm -f .%_datadir/%shortname/%version/lisp/gnus/format-spec*
%__rm -rf .%_datadir/%shortname/%version/lisp/gnus 
%__rm -f .%_infodir/{gnus,emacs-mime,message}*
%__rm -rf .%_datadir/%shortname/%version/etc/gnus*

%__rm -f .%_infodir/info*


################
# Menu support #
################
%__install -d $RPM_BUILD_ROOT%_menudir
%__install -p -m644  %SOURCE22 $RPM_BUILD_ROOT%_menudir/%name-X11
%__install -p -m644 -D %SOURCE12 .%_miconsdir/%name.xpm
%__install -p -m644 -D %SOURCE13 .%_iconsdir/%name.xpm
%__install -p -m644 -D %SOURCE14 .%_liconsdir/%name.xpm

########################
# Alternatives support #
########################
%__install -d $RPM_BUILD_ROOT%_altdir
%__install -p -m644 %SOURCE24 $RPM_BUILD_ROOT%_altdir/%name

###############
# X resources #
###############
xrdir=%_sysconfdir/X11/app-defaults
%__mkdir_p ."$xrdir"
%__install -p -m0644 %SOURCE31 ."$xrdir/Emacs"
unset xrdir


popd # "$RPM_BUILD_ROOT"

#####################
# Create file lists #
#####################
# INFO
%define common_infos ada-mode,autotype,ccmode,cl,dired-x,ebrowse,ediff,efaq,%shortname,eshell,eudc,forms,idlwave,mh-e,pcl-cvs,reftex,sc,vip,viper,widget,woman
%define gnus_infos emacs-mime,gnus,message
%define gnus_infos_pattern gnus\\|emacs-mime\\|message

# source emacs pgktools (bash functions that call el-functions)
. %_libdir/%shortname/el-pkgutils.sh
EMACS_BIN="%name-nox"
EMACS_SEARCH_ROOT="$RPM_BUILD_ROOT"
EL_PKGUTILS_ROOT=""
# Clear the lists:
%__rm -f {main,leim}{,-el}.ls info.ls

# Generate them:
# INFO
common_infos=( $(ls "$RPM_BUILD_ROOT"%_infodir/*.info* \
| sed -e "s:^$RPM_BUILD_ROOT%_infodir/::" \
| sed -e 's:\.info.*$::' | sort -u \
| egrep -v %gnus_infos_pattern ) )

( # save IFS
IFS=,
if [[ '%common_infos' != "${common_infos[*]}" ]]; then
	echo "common_infos lists do not match, correct them!"
	exit 1
fi
) || false

fraction \
 '(dirs "%_libdir/%shortname/%version" "%dir") "main.ls"' \
 '(files "%_libdir/%shortname/%version" 
    (lambda(f) (if (string-match "/movemail$" f) "%attr(-,root,mail)")) )
  "main.ls"' \
 \
 '(dirs "%_datadir/%shortname/%version/etc" "%dir") "main.ls"' \
 '(files "%_datadir/%shortname/%version/etc" 
    (lambda(f) (if (string-match "gnus" f) "#")) )
  "main.ls"' 

standard_fraction_el_elc main "%_datadir/%shortname/%version/lisp"
standard_fraction_el_elc leim "%_datadir/%shortname/%version/leim"

# INFO
printf '%s\n' %_infodir/{%common_infos}'.info*' >> main.ls

# Prepare the trick for linking etc/ into docs:
%__ln_s %_datadir/%shortname/%version/etc etc/

# common
%post common
%register_alternatives %name -- emacs
%install_info {%common_infos}.info

%preun common
%unregister_alternatives %name
%uninstall_info {%common_infos}.info

# nox
%post nox
%update_alternatives
%preun nox
%remove_alternatives %_bindir/emacs21-nox

# X11
%post X11
%update_alternatives
%update_menus

%preun X11
%remove_alternatives %_bindir/emacs21-X11

%postun X11
%clean_menus

#
%files common -f main.ls
%doc AUTHORS BUGS README README.KOI8-U README.UK CHANGES.ukr INSTALL.ukr
# The trick for symlinking etc/:
%doc --no-dereference etc/etc

# %config(noreplace) %_sysconfdir/emacs/site-start.d/php.el

%_altdir/%name

%_bindir/*
%exclude %_bindir/%name-nox
%exclude %_bindir/%name-X11

%_mandir/man?/*

%dir %_libdir/%shortname/site-lisp

#%dir %_emacslispdir
%_emacslispdir/*.el*
%dir %_datadir/%shortname/%version
%dir %_datadir/%shortname/%version/site-lisp
%_datadir/%shortname/%version/site-lisp/*
%dir %_datadir/%shortname/%version/leim

# Some .el-files that have .elc-companions,
# but are still preferrable to have in the main
# package (for reference) may be listed here:
#%_datadir/%name/%version/lisp/bindings.el -- probably there is no need for this
#%_datadir/%name/%version/lisp/mail/sc.el
#%_datadir/%name/%version/lisp/term-nasty.el

# This should be a symlink
%_datadir/emacs/%version/lisp/site-start.el

%_sysconfdir/emacs/site-start.d/*

%files el -f main-el.ls

#
%files leim -f leim.ls

%files leim-el -f leim-el.ls

#
%files nox
%_bindir/%name-nox

#
%files X11
#%_bindir/%name-%version
%_bindir/%name-X11

%config(noreplace) %_sysconfdir/X11/app-defaults/*

%_menudir/%name-X11

%_iconsdir/%name.xpm
%_miconsdir/%name.xpm
%_liconsdir/%name.xpm

%changelog
* Sat Aug 20 2005 Igor Vlasenko <viy@altlinux.ru> 21.3-alt11.M24.vla2
- M24 backport of alt12-release-candidate-2 (21.3-alt11.vla2)
- It should fix bugs of Master24's alt10
- for complete list of bugs see chamgelog of 21.3-alt11.vla1

* Thu Jul 07 2005 Igor Vlasenko <viy@altlinux.org> 21.3-alt11.vla2
- added conflict with ispell-uk<0.6

* Thu Jun 30 2005 Igor Vlasenko <viy@altlinux.org> 21.3-alt11.vla1
- fixed bug #6853 shift+7 in cyrillic-ukrainian-ms
- fixed bug #835 (added belarussian ispell dict)
- fixed bug #6855 (re-added ukrainian ispell dict)
- fixed bug #6842 (patched emacs21-rus-win-keyboard.el)

* Fri Feb 11 2005 Kachalov Anton <mouse@altlinux.ru> 21.3-alt11
- support for x86_64 (#6089)

* Fri Sep 17 2004 ALT QA Team Robot <qa-robot@altlinux.org> 21.3-alt10.1.1
- Rebuilt with libtiff.so.4.

* Thu Jun 10 2004 Stanislav Ievlev <inger@altlinux.org> 21.3-alt10.1
- NMU: fix alternatives usage (rename candidates in remove_alternative macros)

* Mon May 03 2004 Ott Alex <ott@altlinux.ru> 21.3-alt10
- Fix bug #2676
- Fix bug #883
- Fix bug #1159
- Fix bug #1502
- Fix bug #2217
- Fix bug #3885
- Fix bug #2566

* Sat Mar 27 2004 Ott Alex <ott@altlinux.ru> 21.3-alt9
- Fixing entry in menu

* Sat Jan 31 2004 Ott Alex <ott@altlinux.ru> 21.3-alt8
- Fixing entry in menu
- Install new smtpmail with support of SMTP Auth

* Mon Jan 12 2004 Ott Alex <ott@altlinux.ru> 21.3-alt7
- Fixing spec to properly rebuild

* Sat Jan 10 2004 Ott Alex <ott@altlinux.ru> 21.3-alt6
- Name changed to emacs21 
- Remove compression of .elc files
- Remove dependence on speedbar
- Remove gnus and dependence on it
- Added missed buildreq on sendmail
- Move emacs-pkgtools to emacs-base

* Sun Nov 30 2003 Ott Alex <ott@altlinux.ru> 21.3-alt5
- Reorganize package 
- move php-mode.el to emacs-prog-modes package

* Wed Apr 09 2003 Stanislav Ievlev <inger@altlinux.ru> 21.3-alt4.1
- new alternatives format

* Fri Apr  4 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt4
- lisp: autoload `cyrillic-encode-koi8-r-char' (was lost in patch20 "uk")

* Tue Apr  3 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt3
- mouse & PRIMARY X selection: restore the behaviour introduced
  by 21.2-alt11-clipboard.patch (lost in 21.3-alt1; patch3)

* Tue Apr  1 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt2
- built-in `load': always use the load-handler if it is present 
  (e.g. for compressed .elc's; fixes No. 0002355; patches 11 and 12);
- lisp: 
  + `vc-cvs-registered' function: split into parts for autoloading
    without any loops (No. 0002334 at bugs.altlinux.ru; patch13);
  + php-mode updated to 1.04;
- docs: include AUTHORS, symlink etc/;
- spec:
  + make updates (regenerate autoloads, cus-deps etc.) at the %%build stage;
  + supply install-info path to %%makeinstall (to get less error msgs);

* Tue Mar 25 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.3-alt1
- new upstream version;
- files: include /usr/bin/{ebrowse,grep-changelog} in emacs-common pkg
  (No. 0002354 at bugs.altlinux.ru)
- Cyrillic support improvements (patch33):
  + language-env detection improved for be*, ru*, uk* & *iso8859-5 locales;
  + info manual reflects the support for various Cyrillic-based language-envs
    (based on the "uk" patch);
  + Ukrainian word for "Ukrainian" fixed in HELLO (No. 0002213);
- spec & patches (not visible to a user): 
  + simplify the menu file (s:%%version:X11:);
  + include /usr/bin/* in emacs-common pkg (and exclude emacs-{nox,X11});
  + patch3 (clipboard): default xselection coding-system value is already correct upstream;
  + patch9 (regex-encoded): upstream (not ours);
  + patch20 (uk): redone, some parts extended and moved to patch33 (more-cyrillic);
  + patch31 (dumbterm-for-compile): finally upstream;
  + patch32 (cp866fix): upstream;

* Fri Mar 14 2003 Stanislav Ievlev <inger@altlinux.ru> 21.2-alt16
- PreReq fixes

* Wed Mar 12 2003 Stanislav Ievlev <inger@altlinux.ru> 21.2-alt15
- moved to new alternatives scheme
- warning to maintainer: added missing PreReq on update-alternatives


* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt14
- changes to better support various Cyrillic X fonts 
  (news in patch33):
  + faces.el: face-font-registry-alternatives: list the wide-spread 
    alternatives for Cyrillic iso8859-5 (microsoft-cp1251, koi8-u, koi8);
  + fontset.el: leave "ISO8859-5" as the REGISTRY-ENCODING for Cyrillic;
  + fontset.el: change the FAMILY for Cyrillic from "*" (any) to nil 
    (the same a sthe default), because Cyrillic is like Latin: the family
    plays just hte same role;
  + describe koi8-c X font encoding (for now, just as an alias for koi8-u);
  (patch10):
  + make :slant the most important property when selecting a font for a face
    (imho, the absence of slanted fonts makes the visual appearance dull);
  (source31):
  + remove all font-related settings from /etc/X11/app-defaults/Emacs (which
    used to be brute), add only "Emacs.default.attributeFamily: fixed";
  + now, there is no need to specify rather brute values in localized
    /etc/X11/Xresources.* in order to get the right encoded Cyrillic font --
    we get it without any special X resources, if the Cyrillic font is 
    available (modify app-defaults accordingly!);
    (a part of the fix for No. 0000825, 0001478, 0001681; complete 0000997);
- open bzipped2 .el files (as well as gzipped which was supported before)
  when following links from the Help buffer (e.g., C-h v) (patch1;
  fixes No. 0001927 at http://bugs.altlinux.ru).

* Mon Feb 10 2003 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt13
- fix regex processing for some specially encoded texts (patch9, useful
  for Gnus, sent by Alex Ott <ottalex@narod.ru>);
- add BuildRequires(install): bzip2-utils (to fix No. 0001911).

* Sun Dec  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt12
- files: 
  + include non-el/elc files from lisp/ (mainly xpm; fixes No. 0001387);
  + exclude gnus/ from emacs-common (it was included in a previous revision);
  + compress .el-files in *-el pkgs;
- corrected TUTORIAL.ru (Alex Ott <ottalex@narod.ru>);
- spec-file: thoroughly check that all info-files are included
  (fixes No. 0001386);

* Sun Nov 17 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt11
- make possible primary X selection setting & pasting with mouse
  (in addition to clipboard manipulation with keys; fixes No. 1356);
- pc-selection-mode: turn-offable; no conflict with traditional 
  selection manipulation keys (like C-space; fixes No. 1357 at 
  bugs.altlinux.ru);
- lisp/ediff-diff.el: refine the check for valid ediff-diff-options;

* Sat Nov  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt10
- make finer distinction between koi8-r & koi8-u font encodings
  (fixes No. 997 at bugs.altlinux.ru).

* Fri Nov  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt9
- make keys like C-h, M-x work even when the (say) Russian XKB 
  group is active (patch5, discard almost the whole state if
  a certain modifier is detected; fixes No. 852 at bugs.altlinux.ru).
  (Please REPORT any related misbehaviors!)

* Thu Nov  7 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt8
- use --host=%%_target_platform for ./configure (fixes No. 1535
  at bugs.altlinux.ru).

* Tue Nov  5 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt7
- lisp: leave gnus/format-spec.el* in the main pkg (do not put in gnus):
  kind of essential library (required by tramp);
- scripts:
  + do not install {dir,info}.info; do install idlwave.info;
  + do not install speedbar.info (belongs to the speedbar package);
    WARNING: unless you reinstall emacs-speedbar, its info entry won't
    appear in the catalog;
- gnus subpkg:
  + Provides: gnus = %%name:%%version-%%release; Conflicts: gnus !=...; 
    I suppose other Gnus pkgs should do the same;
  + move {emacs-mime,message}.info to this subpkg.

* Sun Nov  3 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt6
- install more info;
- separate gnus{,-el} (alternatives would be complex in this case due to
  info and etc/, so other gnus should merely conflict with these ones).

* Fri Jul 19 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt5
- follow the convention about using POSIX locks (with fcntl(2)) for 
  mailbox access (in movemail; nnmbox users take care on your own!);
- drop privileges of movemail utility (no dot-locking in /var/mail/); 
- link with tinfo, not ncurses (everything is there in the latest release);
- remove termcap from build deps;
- lisp: drop speedbar.el{,c}, speedbar.info -- you will find it 
        in a separate pkg (Alex Ott <ottalex@narod.ru>);
- etc: add TUTORIAL.ru (Alex Ott);
- rcs-checkin: hide the dependencies on rcs (mhz).

* Sun Apr 14 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt4
- lisp: 
  + add support for X Compound Text with Extended Segments
    in koi8-u and microsoft-cp1251 (koi8-r support already present
    in the offcial GNU release; this is the complete fix for \#786
    at bugs.altlinux.ru);
  + add cp1251 item to the list of choices for ispell coding;
- package:
  + correct preun-scripts (alternative management) (Sorry, you will 
    have to uninstall 21.2-alt3 manually with --noscripts);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt3
- rename: /usr/bin/emacs-21.2 to /usr/bin/emacs-X11
  (to overcome the alternatives nightmare);

* Fri Apr 12 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt2
- package: 
  + add Confilcts on older etcskel & app-defaults (the
    old ones use values considered bad for 21.2);
  + Groups of *-el subpkgs changed to Development/Other;
- lisp: add support for X fonts in koi8 and *1251;


* Mon Apr  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.2-alt1
- new mainstream release (21.2):
  + now supports ICCCM Extended Segments in X selctions (fixes \#786 at
    bugs.altlinux.ru) -- don't forget to sync etcskel's to use c-text 
    for selections;
- lisp: 
  + prefer clipboard over primary selection (the reasononig given in
    \#795 at bugs.altlinux.ru);
  + the default value for selection-coding-system: 
    compound-text -> compound-text-with-extensions (this is the second part of
    the fix for \#786 at bugs.altlinux.ru)
  + Encoded-kb mode indicator turned off in mainstream release, so 
    we are not applying our previous patch any more;
-config:
  + use "Emacs" class as a specifier for X resourcers (was: "emacs" name)
    (fixes \#764 at bugs.altlinux.ru) -- don't forget to sync /etc/Xresources;
- spec-file:
  + dumbterm-for-compile patch regenerated;
  + alternatives: 
    * weights for alternatives shifted by %{alternativeMajor}00;
    * removal in %%preun to avoid collisions;

* Thu Mar  1 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt13
- fix broken deps between emacsen-startscripts and and emacs-{X11,nox}:
  the pkgs with Emacs executables now provide `emacsen'.

* Thu Feb 28 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt12
- make co-existence with other Emacsen (XEmacs) easier:
  + move the site start scripts to a separate pkg (emacsen-startscripts; 
    they should be shared between GNU and X- Emacsen); buildreq rules for
    the directory with the scripts also moved to that pkg;
  + emacs-{nox,X11} provide emacsen (should be also provided 
    by XEmacs binaries);
  + emacs-{nox,X11} require emacsen-startscripts (should be also required 
    by XEmacs binaries);

* Sat Feb 25 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt11
- get rid of the inconsistency in versions and documentation data between 
  emacs-X11 and emacs-nox variants (fixes \#601, \#612 in bugs.altlinux.ru)
  (%%build stage modified to achieve this);
- add more strict %%release dependencies;
- add support for loading bzipped2 .el/.elc; compress several large files;
- lisp:
    + encoded-kbd: make indicator string shorter;
    + cyrillic-codepages-setup: override `valid-codes' property with more 
      correct values (this fixes hanging on C-x; Note: if you do 
      codepage-setup manually, then it is not fixed for you);
- config:
    + macros: rename noXlaunch -> TTYlaunch;
    + mouse: attempt to use mouse in Linux console and Xterm;
    + initial-features: turn on column-number and eldoc (for el only) modes;
- spec-file:
  + %%install: handle menu simpler;
  + make a patch instead of the separate HELLO.re (append it to Patch20);
  + %%install: generate filelists using el-pkgutils (it should be used also
    in other pkgs with Emacs Lisp code);

* Sun Feb  9 2002 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt10
- lisp: 
  + new version of php-mode (1.0.2); compile it;
    on site-start, initialize autoload of it (php-mode);
  + add more seamless support for Cyrillic language environments based
    on CP1251, CP866 and CP1125;
  + fix CP866 table;
- config:
  + special bindings for selection management discarded -- the defaults 
    work fine (even for X); support for analogous KeyPad bindings added 
    (suggested by vyt@vzljot.ru);
  + X resources: set our values for colour classes; use "Helv" font 
    family for the menu;
  + do not fail completely if the Flyspell feature fails;
  + mouse wheel support turned on;
  + defined GNU-/XEmacs and Xlaunch macros (to be used in personal configs, etcskels);
  + split the config into small parts;
- menu: explicitly specify the X11-variant of emacs;
- spec-file:
  + Head: thrown away unused and recompiled sources; 
    not used terminfo patch left for a while: do we need it??;
  + build: do not copy any byte-compiled .elc files into the build 
    tree -- all of them now get recompiled from the patched sources 
    (particularly quail/cyrillic.elc from leim);
  + install: move menu entry to a separate file;
  + scriplets: use %%*_menus macros;
  + install: cut down "$RPM_BUILD_ROOT" usage;
  + detect errors during Emacs Lisp compilation;

* Thu Jan 24 2002 Dmitry V. Levin <ldv@alt-linux.org> 21.1-alt9
- Added emacs filter for buildreq.

* Thu Dec 27 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt8
- configuration:
  + really turn on pc-selection-mode;
  + move frame properties from site-start.el to X resources;
- lisp: really apply our patches by recompiling the patched sources;
- .el/.elc fractions improved:
  + do not loose any not-compiled .el-files in the emacs-common pkg;
  + split emacs-el into emacs-el and emacs-leim-el subpkgs;
- "TERM in Compile" patch extended (idea by rms@gnu.org);

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt7
- inherit ispell-dictionary value from the DICTIONARY environment variable
- fix the "TERM in Compile" patch -- now it works

* Wed Dec 26 2001 Ivan Zakharyaschev <imz@altlinux.ru> 21.1-alt6
- configuration from MdkRE's etcskel-* merged into the global Emacs' config
- set TERM=dumb for compile (for nice output of colorgcc and other programs)
- set ownership on various directories for clean pkg removal
- FAQ excluded from the documentation

* Tue Nov 20 2001 AEN <aen@logic.ru> 21.1-alt5
- update-alternatives fixed (bug 168,169)
- new php-mode.el (bug 170)

* Thu Nov 15 2001 AEN <aen@logic.ru> 21.1-alt4
- fix typo in previous changelog record
- some MDK improvements added

* Tue Nov 13 2001 AEN <aen@logic.ru> 21.1-alt3
- ukrainiazation from Serhii Hlodin

* Thu Nov 1 2001 AEN <aen@logic.ru> 21.1-alt2
- leim cyrillic patches restored

* Mon Oct 22 2001 AEN <aen@logic.ru> 21.1-alt1
- new version

* Fri May 18 2001 Stanislav Ievlev <inger@altlinux.ru> 20.7-ipl9mdk
- Repackaged.
- Moved common %name stuff to %name-common subpackage.
- Used update-alternatives for %name-nox and %name-X11 subpackages.
- Fixed terminfo linkage.

* Sat Feb 17 2001 AEN <aen@logic.ru>
- groups names fixed

* Sat Jan 20 2001 AEN <aen@logic.ru>
- belarusian script in HELLO fixed (Alexander Bokovoy)

* Tue Dec 26 2000 AEN <aen@logic.ru>
- spec cleanup

* Thu Dec 07 2000 AEN <aen@logic.ru>
- 20.7
- rebuild for 7.2RE

* Sat Mar 11 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- load belarusian code at startup

* Thu Jan 13 2000 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- added belarusian language support

* Tue Nov 9 1999 AEN <aen@logic.ru>
- bzipped man-pages
- custom.gz removed
- build for 6.1RE

* Fri Sep 17 1999 Oleg Tihonov <tihonov@ffke-campus.mipt.ru>
- move to 20.4
- add Ukrainian patches

* Wed May 26 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- move the %_bindir/%name script to the %name package

* Wed May 26 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- s/arch-redhat-linux/arch-mandrake-linux
- replace %name with a shell script that runs either %name-nox or
  %name-20.3
- s/%name/%name-20.3/ in %name.wmconfig (wmconfig is always X)

* Fri Apr 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adpatations.
- Bzip2 info/man pages.
- Path to handle bzip2 on info files.

* Wed Mar 31 1999 Preston Brown <pbrown@redhat.com>
- updated mh-utils %name lisp file to match our nmh path locations

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 9)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- linker scripts hack to make it build on the alpha

* Fri Jan  1 1999 Jeff Johnson <jbj@redhat.com>
- add leim package (thanks to Pavel.Janik@inet.cz).

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Wed Sep 30 1998 Cristian Gafton <gafton@redhat.com>
- backed up changes to uncompress.el (it seems that the one from 20.2 works
  much better)

* Mon Sep 28 1998 Jeff Johnson <jbj@redhat.com>
- eliminate /tmp race in rcs2log

* Wed Sep 09 1998 Cristian Gafton <gafton@redhat.com>
- upgrade to 20.3

* Tue Jun  9 1998 Jeff Johnson <jbj@redhat.com>
- add --with-pop to X11 compile.
- include contents of %_datadir/.../etc with main package.

* Mon Jun 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr

* Mon Jun 01 1998 David S. Miller <davem@dm.cobaltmicro.com>
- fix signals when linked with glibc on non-Intel architectures
  NOTE: This patch is not needed with %name >20.2

* Thu May 07 1998 Prospector System <bugs@redhat.com>

- translations modified for de, fr, tr

* Thu May 07 1998 Cristian Gafton <gafton@redhat.com>
- added %_libdir/%name/20.2/*-mandrake-linux directory in the filelist

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- alpha started to like %name-nox again :-)

* Thu Nov  6 1997 Michael Fulbright <msf@redhat.com>
- alpha just doesnt like %name-nox, taking it out for now

* Mon Nov  3 1997 Michael Fulbright <msf@redhat.com>
- added multibyte support back into %name 20.2
- added wmconfig for X11 %name
- fixed some errant buildroot references

* Thu Oct 23 1997 Michael Fulbright <msf@redhat.com>
- joy a new version of %name! Of note - no lockdir any more.
- use post/preun sections to handle numerous GNU info files

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- stopped stripping it as it seems to break things

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>
- turned off ecoff support on the Alpha (which doesn't build anymore)

* Mon Jun 16 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Fri Feb 07 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved ctags to gctags to fit in the more powerful for C (but less
  general) exuberant ctags as the binary %_bindir/ctags and the
  man page /usr/man/man1/ctags.1
# Local Variables:
# compile-command: "rpmbuild -ba --target=i586 emacs.spec"
# End:
